<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>EnhancedPopupMenu xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/ucm/core/menu/EnhancedPopupMenu.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2017 CEA LIST and Thales</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *    Inspired from similar class by Christian W. Damus</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *    Ansgar Radermacher - additional sub-menu functions</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *   </em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.ucm.core.menu;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.Iterator;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.Assert;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.diagram.ui.menus.PopupMenu;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.ILabelProvider;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.viewers.IStructuredContentProvider;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.window.Window;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.widgets.editors.TreeSelectorDialog;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.widgets.providers.EncapsulatedContentProvider;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.SWT;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionEvent;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionListener;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Display;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Menu;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.MenuItem;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment"> * A specialized {@link PopupMenu} that supports the insertion of</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment"> * (1) {@linkplain Separator separators} into the menu.</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment"> * (2) Disabled elements</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment"> * (3) Sub-menu selections</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/menu/EnhancedPopupMenu.html">EnhancedPopupMenu</a> <strong class="jxr_keyword">extends</strong> PopupMenu {
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <em class="jxr_javadoccomment">	 * Initializes me with my menu contents (including, potentially, {@link Separator}s)</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <em class="jxr_javadoccomment">	 * and a label provider.</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/menu/EnhancedPopupMenu.html">EnhancedPopupMenu</a>(List&lt;?&gt; aContent, ILabelProvider aLabelProvider) {
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  		<strong class="jxr_keyword">super</strong>(aContent, aLabelProvider);
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  	}
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	@Override
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> createMenuItems(Menu parentMenu, PopupMenu rootMenu,
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  			@SuppressWarnings(<span class="jxr_string">"rawtypes"</span>) <strong class="jxr_keyword">final</strong> List resultThusFar) {
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  		Assert.isNotNull(getContent());
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  		Assert.isNotNull(getLabelProvider());
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  		EnhancedPopupMenu rootMenuWithSeparators = (EnhancedPopupMenu) rootMenu;
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  		<strong class="jxr_keyword">for</strong> (Iterator&lt;?&gt; iter = getContent().iterator(); iter.hasNext();) {
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  			Object contentObject = iter.next();
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  			MenuItem menuItem;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  			<strong class="jxr_keyword">if</strong> (contentObject instanceof CascadingMenu) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  				EnhancedPopupMenu subMenu = (EnhancedPopupMenu) ((CascadingMenu) contentObject)
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  						.getSubMenu();
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  				contentObject = ((CascadingMenu) contentObject)
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  						.getParentMenuItem();
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  				@SuppressWarnings(<span class="jxr_string">"unchecked"</span>)
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  				List&lt;Object&gt; thisResult = <strong class="jxr_keyword">new</strong> ArrayList&lt;&gt;(resultThusFar);
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  				thisResult.add(contentObject);
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  				menuItem = <strong class="jxr_keyword">new</strong> MenuItem(parentMenu, SWT.CASCADE);
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  				menuItem.setMenu(<strong class="jxr_keyword">new</strong> Menu(parentMenu));
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  				subMenu.createMenuItems(menuItem.getMenu(), rootMenu,
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  						thisResult);
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (contentObject instanceof Separator) {
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  				menuItem = <strong class="jxr_keyword">new</strong> MenuItem(parentMenu, SWT.SEPARATOR);
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  				menuItem = <strong class="jxr_keyword">new</strong> MenuItem(parentMenu, SWT.NONE);
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  			}
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  			<strong class="jxr_keyword">if</strong> (contentObject instanceof Disabled) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  				contentObject = ((Disabled) contentObject).content;
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  				menuItem.setEnabled(false);
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  			}
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  			<strong class="jxr_keyword">if</strong> (!(contentObject instanceof Separator)) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  				Object selection = contentObject;
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  				<strong class="jxr_keyword">if</strong> (contentObject instanceof SubSelect) {
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  					menuItem.setText(((SubSelect) contentObject).text);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  				}
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  				<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  					menuItem.setText(getLabelProvider().getText(selection));
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  					menuItem.setImage(getLabelProvider().getImage(selection));
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  				}
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  				menuItem.addSelectionListener(<strong class="jxr_keyword">new</strong> SelectionListener() {
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  					@SuppressWarnings(<span class="jxr_string">"unchecked"</span>)
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  					@Override
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 					<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 						resultThusFar.add(selection);
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 						rootMenuWithSeparators.setResult(resultThusFar);
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 					}
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 					@SuppressWarnings(<span class="jxr_string">"unchecked"</span>)
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 					@Override
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 					<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetDefaultSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 						resultThusFar.add(selection);
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 						rootMenuWithSeparators.setResult(resultThusFar);
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 					}
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 				});
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 			}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 	}
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 	<em class="jxr_comment">//</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 	<em class="jxr_comment">// Nested types</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 	<em class="jxr_comment">//</em>
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> <em class="jxr_javadoccomment">	 * In a similar fashion to the {@link PopupMenu.CascadingMenu}, an object</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> <em class="jxr_javadoccomment">	 * that can be added to the menu in order to create a separator, which</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> <em class="jxr_javadoccomment">	 * is not an actionable item.</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/menu/EnhancedPopupMenu.html">Separator</a> {
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 	}
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 	
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L129" href="#L129">129</a> <em class="jxr_javadoccomment">	 * In a similar fashion to the {@link PopupMenu.CascadingMenu}, an object</em>
<a class="jxr_linenumber" name="L130" href="#L130">130</a> <em class="jxr_javadoccomment">	 * that can be added to the menu in order to create a separator, which</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> <em class="jxr_javadoccomment">	 * is not an actionable item.</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/menu/EnhancedPopupMenu.html">Disabled</a> {
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/menu/EnhancedPopupMenu.html">Disabled</a>(Object content) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 			<strong class="jxr_keyword">this</strong>.content = content;
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		}
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 		<strong class="jxr_keyword">public</strong> Object content;
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 	}
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 	
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_javadoccomment">	 * In a similar fashion to the {@link PopupMenu.CascadingMenu}, an object</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_javadoccomment">	 * that will imply a sub-selection in a new box</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/menu/EnhancedPopupMenu.html">SubSelect</a> {
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 		<strong class="jxr_keyword">public</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/ucm/core/menu/EnhancedPopupMenu.html">SubSelect</a>(String text, IStructuredContentProvider contentProvider) {
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 			<strong class="jxr_keyword">this</strong>.text = text;
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 			<strong class="jxr_keyword">this</strong>.contentProvider = contentProvider;
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 		}
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 		<strong class="jxr_keyword">public</strong> String text;
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 		<strong class="jxr_keyword">public</strong> IStructuredContentProvider contentProvider;
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 	}
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 	
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L154" href="#L154">154</a> <em class="jxr_javadoccomment">	 * Get a result that takes possible sub-selection into account.</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> <em class="jxr_javadoccomment">	 * @return the original result or the result of a new selection in a sub-dialog</em>
<a class="jxr_linenumber" name="L156" href="#L156">156</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 	<strong class="jxr_keyword">public</strong> Object getSubResult() {
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		Object result = getResult();
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		<strong class="jxr_keyword">if</strong> (result instanceof SubSelect) {
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 			SubSelect subSel = (SubSelect) result;
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 			TreeSelectorDialog dialog = <strong class="jxr_keyword">new</strong> TreeSelectorDialog(Display.getDefault().getActiveShell());
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 			dialog.setLabelProvider(getLabelProvider());
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 			dialog.setContentProvider(<strong class="jxr_keyword">new</strong> EncapsulatedContentProvider(subSel.contentProvider));
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 			dialog.setTitle(subSel.text);
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 			<strong class="jxr_keyword">int</strong> code = dialog.open();
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 			<strong class="jxr_keyword">if</strong> (code == Window.OK) {
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 				<em class="jxr_comment">// TreeSelectorDialog returns an array.</em>
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 				<strong class="jxr_keyword">return</strong> dialog.getResult()[0];
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 			}
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 		}
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 			<strong class="jxr_keyword">return</strong> result;
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 		}
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 	}
<a class="jxr_linenumber" name="L176" href="#L176">176</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
